// SPDX-FileCopyrightText: 2023 ModExt Authors
//
// SPDX-License-Identifier: Apache-2.0

/*
 * This Java source file was generated by the Gradle 'init' task.
 */

package mod.ext;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Set;
import java.util.stream.Collectors;

import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.formats.TurtleDocumentFormat;
import org.semanticweb.owlapi.io.OWLOntologyDocumentSource;
import org.semanticweb.owlapi.io.OWLOntologyDocumentTarget;
import org.semanticweb.owlapi.io.ReaderDocumentSource;
import org.semanticweb.owlapi.io.WriterDocumentTarget;
import org.semanticweb.owlapi.model.IRI;
import org.semanticweb.owlapi.model.OWLEntity;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;
import org.semanticweb.owlapi.model.OWLOntologyManager;
import org.semanticweb.owlapi.model.OWLOntologyStorageException;
import org.semanticweb.owlapi.model.parameters.Imports;

import uk.ac.manchester.cs.owlapi.modularity.ModuleType;
import uk.ac.manchester.cs.owlapi.modularity.SyntacticLocalityModuleExtractor;

public class App {

    private static OWLOntology loadOntologyFromPath(OWLOntologyManager manager, Path path) throws IOException, OWLOntologyCreationException {
        try (BufferedReader reader = Files.newBufferedReader(path)) {
            OWLOntologyDocumentSource documentSource = new ReaderDocumentSource(reader);
            return manager.loadOntologyFromOntologyDocument(documentSource);
        }
    }

    private static void saveOntologyToPath(OWLOntologyManager manager, OWLOntology ontology, Path path) throws IOException, OWLOntologyCreationException, OWLOntologyStorageException {
        try (BufferedWriter writer = Files.newBufferedWriter(path)) {
            OWLOntologyDocumentTarget documentTarget = new WriterDocumentTarget(writer);
            manager.saveOntology(ontology, new TurtleDocumentFormat(), documentTarget);
        }
    }

    public static void main(String[] args) {

        try {
    
            System.out.println(args[0]);
            OWLOntologyManager manager = OWLManager.createOWLOntologyManager(); 
            Path tboxPath = Paths.get(args[0]);
            Path aboxPath = Paths.get(args[1]);
            Path outputFile = Paths.get(args[2]);
            // Load TBox
            OWLOntology inputTBox = App.loadOntologyFromPath(manager, tboxPath);
            OWLOntology inputABox = App.loadOntologyFromPath(manager, aboxPath);

            long ontologySize = inputTBox.tboxAxioms(Imports.EXCLUDED).count();
            long oldClassesCount = inputTBox.classesInSignature().count();

            System.out.println("Ontology size: " + ontologySize);
            System.out.println("Classes:" + oldClassesCount);

            Set<OWLEntity> seedSignature = inputABox.signature().collect(Collectors.toSet());

            SyntacticLocalityModuleExtractor moduleExtractor = new SyntacticLocalityModuleExtractor(manager, inputTBox, ModuleType.STAR);
            OWLOntology module = moduleExtractor.extractAsOntology(seedSignature, IRI.generateDocumentIRI());
            long moduleSize = module.tboxAxioms(Imports.EXCLUDED).count();
            long classesCount = module.classesInSignature().count();
            System.out.println("Module size: " + moduleSize);
            System.out.println("Number of clases: " + classesCount);
            App.saveOntologyToPath(manager, module, outputFile);
        } catch(IOException | OWLOntologyCreationException | OWLOntologyStorageException e) {
            System.out.println(e.getMessage());
        }
    }

    public static String getGreeting() {
        return "Hello world!";
    }
}

